Revision History
================================================================================
- Version: 1.1.0.1064
- Date Release: 07/03/2013
- Author: Samuel
- Changes:  
1. Support to adjust the delay time in BIOS Post showing devices' messages step.
================================================================================
- Version: 1.1.0.1063
- Date Release: 06/13/2013
- Author: Samuel
- Changes:  
1. Fixed BugID#6470("[UAT-MagniPlus 9235] Using MDU to flash dual HBAs can not select the adapter to be flashed.").
2. Sync the Sorting policy with MVFlash.
3. Extend the Spin-up waiting time to 30 seconds by user setting.
4. Fixed BugID#6481("BIOS can't backup on MDU.").
================================================================================
- Version: 1.1.0.1062
- Date Release: 05/16/2013
- Author: Samuel
- Changes:  
1. Fixed which can't flash multi-cards.
2. Support Buzzer Option Item.
3. Magni, Magni-Lite sync HBA_Info policy with Magni-Plus.
4. Magni, Magni-Lite support SSU.
5. Magni, Magni-Lite support to use the external SPI Flash List Table to flash image.

================================================================================
- Version: 1.1.0.1061
- Date Release: 02/25/2013
- Author: Nai-Chin Huang
- Changes:  
1. Phytest, support more test patterns, including: 
	- LSFR
	- NLBP
	- NCCP
	- Jitter 1T, 2T, 5T, 10T
	- PRBS9, 15, 23, 31
	(1) Modify pattern attribute jitp to jitp0 for Jitter pattern 0 (K28.5).
	(2) Modify pattern attribute prbs to prbs7 for PRBS7 pattern. 
2. Only force Gen3 rate twice when it is for SATA Gen3 and device ID = 9120. (for 9120 esata workaround)

================================================================================

- Version: 1.1.0.1060
- Date Release: 02/05/2013
- Author: Samuel
- Changes:  
1. Support STAGGERED_SPIN_UP by spin_up_group and spin_up_timer controlled.
	(1)spin_up_group: Group 4~1 devices and Spin-Up together.
	(2)spin_up_timer: Wait 1~7 seconds to Spin-Up next group.

================================================================================
- Version: 1.1.0.1059
- Date Release: 12/18/2012
- Author: Samuel
- Changes:  
1. Enable BIST feature.
2. Refer to the external SPI Flash List table("SPILIST.BIN") to flash image
	how to get this image? 
	(1). go to mvflash and make sure it has "spi_info.txt" file 
	(2). type mvf_mag.exe -gspitable
	(3). that will translate the "spi_info.txt" file into "SPILIST.BIN".
	(4). then copy the "SPILIST.BIN" file back to MDU folder.
	(5). next time if that has any new spi flash chip which has to be added, 
	     just only update this file.
3. Support new SPI flash PM25LD51.
================================================================================
- Version: 1.1.0.1058
- Date Release: 12/06/2012
- Author: Samuel
- Changes:  
1. Support to setup the OEM RAID configuration.
================================================================================
- Version: 1.1.0.1057
- Date Release: 11/26/2012
- Author: Samuel
- Changes:  
1. Support FW upgraded Option.
2. Fixed Supermicro's MB wasn’t compatible with activateA20Gate() function.
================================================================================
- Version: 1.1.0.1056
- Date Release: 11/13/2012
- Author: Samuel
- Changes:  
1. Support raid_oem_config_page.
2. Merge VD_Name page to raid_oem_config_page.
3. Import the algorithm of searching devices on PCIE buses from Frank's fix on Plato.
================================================================================
- Version: 1.1.0.1055
- Date Release: 09/21/2012
- Author: Nai-Chin Huang
- Changes:  
1. Fixed BT#5823. Search controllers on all PCI buses.
2. Fixed the SPI existence check.
================================================================================
- Version: 1.1.0.1054
- Date Release: 09/19/2012
- Author: Nai-Chin Huang
- Changes:  
1. Support new SPI for BT#5838 and BT#5839. Support SPI models: PCT25VF0408 and mxic 25l4006. 
2. Fixed BT#5913 [Gigabyte/9172] MDU pop error message on version 1.1.0.1053. Fixed the SPI info pages code flow as BIOS HBA INFO Spec v1.8 for Magni/Magni Lite. Also refine code for command, restore_cfg.
3. Fixed bug which can¡¦t set PHY Rate from 6G to 1.5G.
4. Support BACKUP_CFG command, but disable it now.
5. Support to Hide FREE DISKs. 
6. Fixed Bug which doesn't get HBA_INFO into its own buffer. That has been overwriting the HBA_Info of Buffer 0(for RESTORE_CFG command). 
================================================================================
- Version: 1.1.0.1053
- Date Release: 08/23/2012
- Author: Nai-Chin Huang
- Changes:  
1. Fixed the issue that MDU cannot find the adapters on PCI buses if there are more than 2 adapters with same vendor ID and device ID.
2. Fixed Bug#5847([Aaeon/9235]SATA HDD becomes 1.5Gb after running MDU tool for two 88SE9235 in the same MB )
3. Support to Enable/Disable RAID10 feature.
4. Show RAID features, and add code to dump RAID features.
================================================================================
- Version: 1.1.0.1052
- Date Release: 08/17/2012
- Author: Nai-Chin Huang
- Changes:  
1. Fixed BT#5823. Modify the search algorithm for looking for devices on PCI buses to save time.
================================================================================
- Version: 1.1.0.1051
- Date Release: 06/01/2012
- Author: Nai-Chin Huang
- Changes:  
1. Support New Device ID 9170 and 9186 for Magni Lite.
================================================================================
- Version: 1.1.0.1048
- Date Release: 02/16/2012
- Author: Samuel
- Changes:  
1. Support New Device ID 9215 for Magni-Plus.
2. Support PHY Tuning page.
================================================================================
- Version: 1.1.0.1047
- Date Release: 01/11/2012
- Author: Alex
- Changes:  
[Magni/MagniLite Only]
1. Complete the implementation for latest "BIOS_HBA_page_v1.8" specification. 
1.1 Create a PHY_INFO page in SPI flash pages.
1.2 Redefined checksum in page_header to include page_header only.
1.3 Redefined checksum in HBA_INFO data part to include data part only (not include page_header).
1.4 Redefined next_page to the page number of next page.
1.5 Complete next_page path auto fix feature, when MDU meet a SPI page corrupt.
1.5.1 If MDU find a corrupted page on next_page path, it will update the next_page field of the page before corrupted page to point to the first valid page after corrupted page 
2. Complete PHY tuning feature.
2.1 Enable SPI flash accessing feature in MagniLite
2.2 Add PHY tuning setting item in configure file 9172.txt and 9123.txt.
2.3 Create 9123.txt as configure file for MagniLite.
2.4 MDU will write the PHY tuning setting in configure file to PHY_INFO page in SPI flash when issue ¡§restore_cfg¡¨ command.
3. Enable command "flash -e" for MagniLite.
4. Apply PHY rate setting feature to MagniLite.
4.1 It will apply the PHY rate setting in HBA_INFO page.
5. Fixed BT#5230 : MDU 1.1.0.1043 phytest command fail with 9125 controller 6 and 7 (Total 9125 controller*7)
5.1 Extend to support 8 HBA for new request from PRD.
[Magni/MagniLite/MagniPlus]
6. Let one mdu_mag.exe support Magni, MagniLite and MagniPlus both.
7. Fix BT#5041, sync the information from source code to mdu_readme.txt.
================================================================================
- Version: 1.1.0.1046
- Date Release: 01/04/2012
- Author: Samuel
- Changes:  
1. Add CTL_GPIO_LED option to HBAinfo.(Firmware controls GPIO LED ON/OFF)
================================================================================
- Version: 1.1.0.1045
- Date Release: 11/30/2011
- Author: Samuel
- Changes:  
1. HBA_info keeps on 256 bytes.
2. Add intelligent_init option.
3. Fixed the Adapter info is not correct when connect 3 boards of Magni-Lite and one board of Magni-Plus together.
================================================================================
- Version: 1.1.0.1044
- Date Release: 11/17/2011
- Author: Samuel
- Changes:  
1. Fixed BugId #5187([Asrock/MagniPlus9230]Loopback test cannot be performed on port 2&3 on Magniplus when MagiLite is present).
2. First time go to enable AES that will get fail. Root-problem didn¡¦t assign data_length to HBA_Info.
================================================================================
- Version: 1.1.0.1043
- Date Release: 10/31/2011
- Author: Alex
- Changes:  
1. Fixed BT5144 "MDU cannot check the EEPROM has flashed the option ROM or not"
Solution: Add a parameter "-e" for command "flash".
                   If SPI flash exist, show "SPI Flash is found ."
                   If SPI flash does not exist, show "SPI Flash doesn't exist."
================================================================================
- Version: 1.1.0.1042
- Date Release: 09/07/2011
- Author: Samuel
- Changes:  
1. Support winbond w25x40 Flash chip.
================================================================================
- Version: 1.1.0.1041
- Date Release: 07/22/2011
- Author: Samuel
- Changes:  
1. Support set/get PHY Rate.
================================================================================
- Version: 1.1.0.1040
- Date Release: 07/19/2011
- Author: Samuel
- Changes:  
1. Support new device IDs. AHCI mode(0x9220, 0x9230, 0x9236, 0x9225, 0x9235), IDE mode(0x922A, 0x923A, 0x923B).
================================================================================
- Version: 1.1.0.1039
- Date Release: 07/13/2011
- Author: Samuel
- Changes:  
1. Support Magni-Plus AHCI(9220, 9230) ,IDE Mode(922A, 923A).
2. Support 4 ports of phy test.
================================================================================
- Version: 1.1.0.1038
- Date Release: 06/21/2011
- Author: Alex Tu
- Changes:  
1. change phy setting from ""1:1.5G, 2:3G, 3:6G" to "0:1.5G, 1:3G, 2:6G", 
then host driver ver. 1.2.0.1007 will get correct phy rate setting from hba info page.
================================================================================
- Version: 1.1.0.1037
- Date Release: 04/27/2011
- Author: Samuel
- Changes:  
1. Support Magni-Plus(9200).
================================================================================
- Version: 1.1.0.1036
- Date Release: 03/01/2011
- Author: Ricky Chou
- Changes:  
  1. Fixed if type jitp pattern on phytest, it didn't work.
================================================================================
- Version: 1.1.0.1035
- Date Release: 02/15/2011
- Author: Ricky Chou
- Changes:  
  1. Apply 6G workaround only for Magni 9128/9130 CPU mode.
================================================================================
- Version: 1.1.0.1034
- Date Release: 01/21/2011
- Author: Ricky Chou
- Changes:  
  1. Fixed bug #4162:[GBT]Magni 9128 B1,Run MDU Loopback test fail at SATA 6G test
  [Solution]: Previous build has coding error for port1, now correct it.
================================================================================
- Version: 1.1.0.1033
- Date Release: 01/20/2011
- Author: Ricky Chou
- Changes:  
  1. Fixed bug #4162:[GBT]Magni 9128 B1,Run MDU Loopback test fail at SATA 6G test
  [Solution]: Add workaround for Gen3 rate.
  2. Force Gen3 rate twice for 9120 esata workaround
================================================================================
- Version: 1.1.0.1032
- Date Release: 12/13/2010
- Author: Ricky Chou
- Changes:  
  1.Support ¡§-f¡¨ to stop phytest while error occurred
================================================================================
- Version: 1.1.0.1031
- Date Release: 12/1/2010
- Author: Ricky Chou
- Changes:  
  1.Fixed bug #4123: [MDU]missing parameter supported in 'config -h'.
  2.Fixed bug #4122: [MDU]invalid command from help.
  3.Support Raid0/1/safe/capacity enabled or disabled by restore_cfg
================================================================================
- Version: 1.1.0.1030
- Date Release: 10/19/2010
- Author: Johnny Liu
- Changes:  
  1. Modify negotiated link speed check into phytest function
      it will check link speed by default, and if use -m parameter, it will 
      ignore link speed check.
  2. Change phytest default pattern to PRBS7, and change pattern paramater -n xyz to -n 
  prbs
================================================================================
- Version: 1.1.0.1029
- Date Release: 10/18/2010
- Author: Johnny Liu
- Changes:  
  1. Add TX Emph setting in config
  2. Check Magni/Magni Lite negotiated link speed is PCI Gen 1 or PCI Gen 2
================================================================================
- Version: 1.1.0.1028
- Date Release: 09/28/2010
- Author: Johnny Liu
- Changes:  
  1. Modify the code to use the same binary file on Magni and Magni Lite
================================================================================
- Version: 1.1.0.1025
- Date Release: 08/31/2010
- Author: Ricky Chou
- Changes:  
  1. Remove for loop of phytest due to hardware's suggestion
================================================================================
- Version: 1.1.0.1024
- Date Release: 08/30/2010
- Author: Ricky Chou
- Changes:  
  1. Fix bug #3610: MDU reboots on intel motherboard D975XBX2KR
================================================================================
- Version: 1.1.0.1023
- Date Release: 08/25/2010
- Author: Johnny Liu
- Changes:  
  1. bug #3712:Fixed Magni Lite loopback phytest failed.
  2. Fixed Magni Lite phy config not work issue.
================================================================================
- Version: 1.1.0.1022
- Date Release: 08/20/2010
- Author: Ricky Chou
- Changes:  
  1. bug #3573:Suggestion:Modify the Examples on MDU config cammand.
  2. bug #3572:The illegal option -p on MDU flash command.
  3. support enable/disable hyper hdd feature
================================================================================
- Version: 1.1.0.1020
- Date Release: 08/03/2010
- Author: Ricky Chou
- Changes:  
  1. Fix #3575:[MDU]PHYtest can not be stopped by key board when timer was set unless time up
    - [Root cause]When set timer, didn't check keyboard button.
      [Solution]Check keyboard button when set timer.
================================================================================
- Version: 1.1.0.1019
- Date Release: 07/26/2010
- Author: Ricky Chou
- Changes:  
  1. Fixed BT#3557 - Type "exit" in MDU causes reboot.
     Fixed BT#3567 - There is not the command can exit MDU
    - This issue only happens on specified MB(ASUS P5E) and win98 boot disk. The root cause 
      should be a conflict between win98 boot disk and R/W SPI. So remove Core_Flash_BIOS_Version
      function and this function is useless for Magni product.
================================================================================
- Version: 1.1.0.1018
- Date Release: 06/24/2010
- Author: Ricky Chou
- Changes:  
  1. Fixed BT#3361 - MDU shows "Erase Sector Failed" for HBA of SST 25VF040B flash.
    - The SST25VF040B flash has block write protection in Status Register by default.
    - Clear BP0,1,2,3 to 0 in Status Register to disable the write protection.
================================================================================
- Version: 1.1.0.1017
- Date Release: 05/17/2010
- Author: Tony Chen
- Changes:  
  1. Fix BT#3122 - Restore_cfg with MDU_MAG.exe cannot enable RAID Migration. 

================================================================================
- Version: 1.1.0.1016
- Date Release: 05/06/2010
- Author: Nai-Chin Huang
- Changes:  
  1. Fix BIST Loopback failed issue. 
	- Follow Dishi's instructions to modifiy the register settings for GEN3. 
	- Delay 1000ms after forcing SATA speed and deasserting Reset.

  2. Add compiler option in mmdu.bat to build MDUS.
	- Add a makefile, MAKEFILE_S, for Magni
	- To build mdu_mag.exe, run "mmdu magni". It will generate mdu_mag.exe.
	- To build mdus_mag.exe, run "mmdu magni -s". It will generate mdus_mag.exe.

  3. Change the Magni release folder to have 2 subfolders, mdu_magni and mdus_magni. 

================================================================================
- Version: 1.1.0.1015
- Date Release: 04/27/2010
- Author: Tony Chen
- Changes:  
  1. Fix BT#2468 - MDU can not show Bios version.
     - Add new parameter -g into restore_cfg instruction to show Bios version and HBA Info setting.
  2. Update readme file for restore_cfg -g <id>  instruction.
  3. Rename MDU.exe to MDU_MAG.exe
  4. Fix for multiple cards support

================================================================================
- Version: 1.1.0.1014
- Date Release: 03/31/2010
- Author: Derek CC Chen
- Changes:  
  1. Fix BT#2752 - MDU backup function doesn't work.
  2. Fix BT#2089 - MDU in SP1107 failed to flash HBA.
     - Update the flash -m parameter instruction to use full folder name path or start from current folder name.
  3. Enable commands: FLASH and RESTORE_CFG.
  4. Add 9122 and 91A2 device ID support.
  5. Update readme file for flash -m instruction.

================================================================================
- Version: 1.1.0.1013
- Date Release: 01/21/2010
- Author: Nai-Chin Huang
- Changes:  
  1. add new commands for SATALAB requests.
    (1) bist: BIST Retimed Loopback mode support by given port id and phy rate. 
              Currently support 0:Gen1/1.5G, 1:Gen2/3G, 2:Gen3/6G.
    (2) pm: Power management(PM) support by given port id and mode request. 
            Currently support 
              0: Disable
              1: Enable power saving and send out PMREQ_P
              2: Enable power saving and send out PMREQ_S
  2. Disable commands, FLASH and RESTORE_CFG, for SATALAB release. 

================================================================================
- Version: 1.1.0.1012
- Date Release: 01/05/2010
- Author: 
- Changes:  
  1. Modify flash flow support user defined folder
  2. Add restore_cfg [-f <filename>][-i <adapter id>] to set HBA Info Page
  
================================================================================
- Version: 1.1.0.1011
- Date Release: 10/23/2009
- Author: 
- Changes:  
  1. Replace Jitter and PRBS default pattern from PRBS 7 to 1Ts
  
================================================================================
- Version: 1.1.0.1010
- Date Release: 10/20/2009
- Author: 
- Changes:  
  1. Modify phytest wording to avoid confusing.
  2. Fix phytest wrong return code when one test is failed, but others are passed.
  
================================================================================
- Version: 1.1.0.1009
- Date Release: 09/22/2009
- Author: 
- Changes:  
  1. Modify phytest flow, don't do reset HBA.
  2. Modify phytest to support break during test.

================================================================================
- Version: 1.1.0.1008
- Date Release: 09/17/2009
- Author: 
- Changes:  
  1. Add pattern select in phytest.
  2. Support multiple adapters
  3. Modify config display info

================================================================================
- Version: 1.1.0.1007
- Date Release: 08/27/2009
- Author: 
- Changes:  
  1. Modify phytest to make it flexible in parameter input.

================================================================================
- Version: 1.1.0.1006
- Date Release: 08/21/2009
- Author: 
- Changes:  
  1. Add config function to do phy tune

================================================================================
- Version: 1.1.0.1005
- Date Release: 08/13/2009
- Author: 
- Changes:  
  1. Fixed device detected wrong issue.
  2. Add phytest duration for customer have enough time to get eye diagram.
  3. Add flash -m [any directory]

================================================================================
- Version: 1.0.0.1004
- Date Release: 07/29/2009
- Author: 
- Changes:  
  1. Fixed function 1 detected first on some MB, which result in MDU function not work
  
================================================================================
- Version: 1.0.0.1003
- Date Release: 07/13/2009
- Author: 
- Changes:  
  1. Fixed phytest reset HBA failed in CPU mode

================================================================================
- Version: 1.0.0.1002
- Date Release: 07/10/2009
- Author: 
- Changes:  
  1. Fixed mvflash wrong version issue.

================================================================================
- Version: 1.0.0.1001
- Date Release: 07/08/2009
- Author: 
- Changes:  
  1. First release.

